/******************************************************************************
*                         Steffen Hofmann                                     *
*                             shotech                                         *
*******************************************************************************
*  $Source: ,v $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  17.09.2017 13:53:08
*  Geraete Bezeichnung   :  UB88xx TB4 
*-----------------------------------------------------------------------------*
*- $Id:  ub88xx@shotech.de 
*-----------------------------------------------------------------------------*
*
*	sourcefile
*	----------
*	main
* UB8820 oder UB8840
*
******************************************************************************/


#include "hw.h"
#include "main.h"
#include "uart.h"
#include "timer.h"
#include "utils.h"
#include "adc.h"
#include "tft_drv.h"
#include "firmware.h"
#include <Limits.h>
#include <stdio.h>
#include <string.h>

const char coStartText[]={"UB8820 MON V1.0"};
const char coRegisterText[]={"Register Set"};
const char coSPLText[]={"SPL: "};
const char coSPHText[]={"SPH: "};
const char coFlagsText[]={"FLAGS: "};


interrupt void Dummy(void);

int main ()
{
  unsigned short wCount;
  register u8 bReg;
//  BOOL bRam = TRUE;
//  unsigned char far volatile *pbRam;
    char bAdcWert[20];
  
  //P3M |= PORT_P3M_nDM;
  
	IMR = 0x00;			        //- Disable IRQ
	IRQ = 0;			          //- Reset IRQ
	
	P2 &= ~PORT_P2_DC_TFT;
	CONF_CPLD = CONF_CPLD_WR_DISABLE;   //- EPROM Write Disable ( EPROM Simulator SRAM oder FRAM )
	
	LED_PORT = 0x00;
	//- Init ADC alles Low
	ADC_CONFIG = 0;
	
//	init_uart();           //- Init UART 19200 Baud

	//init_timer1();         //- Init Timer 1 als Timetick 10ms


//	ssd1283_ghw_init();
	st7735_ghw_init();
	Output_Clear();
	for( wCount = 0; wCount < 30000; wCount++);
	FillScreen(G_RED);
	FillScreen(G_GREEN);
	FillScreen(G_BLUE);
	
	
//	EI();				           //- Enable Interrupts.
	//- Systemstart Meldung ber RS232 ( USB )

	DrawString(1, 1, (char*)coStartText, G_YELLOW, G_BLUE );
	DrawString(1, 3, (char*)coRegisterText, G_YELLOW, G_BLUE );
	
	
  memcpy( bAdcWert, (char*)coSPLText, sizeof( coSPLText) );
  bReg = SPL;
  BinToAsciiHexB(bReg, &bAdcWert[5]);
  DrawString(1, 4, (char*)bAdcWert, G_YELLOW, G_BLUE );
  
  memcpy( bAdcWert, (char*)coSPHText, sizeof( coSPHText) );
  bReg = SPH;
  BinToAsciiHexB(bReg, &bAdcWert[5]);
  DrawString(1, 5, (char*)bAdcWert, G_YELLOW, G_BLUE );

  memcpy( bAdcWert, (char*)coFlagsText, sizeof( coFlagsText) );
  bReg = FLAGS;
  BinToAsciiHexB(bReg, &bAdcWert[7]);
  DrawString(1, 6, (char*)bAdcWert, G_YELLOW, G_BLUE );
  	
//	sendConstChar( &coStartText[0], sizeof(coStartText));
//  while(1)
//  {
//     ghw_writeCommand( 0x55 );
//     ghw_writeData( 0xAA );  	
//  	
//  }
	

    		 
   while(1)
   {
		  LED_PORT = 0x55;
    
		  for( wCount = 0; wCount < 30000; wCount++);

		  LED_PORT = 0xAA;

      
		  for( wCount = 0; wCount < 30000; wCount++);
	}   	
   	

//	while(1){
//
//		LED_PORT = 0x55;
//    //- Aktuelle Betriebsspannung lesen
//    bAdc = AdcReadData( ADC_CHANNEL_SUPPLY );
//      
//      BinToAsciiHexB(bAdc, bAdcWert);
//      bAdcWert[2]= '\n';
//      sendChar( bAdcWert, 3);
//    
//		for( wCount = 0; wCount < 30000; wCount++);
//
//		LED_PORT = 0xAA;
//
//    //- Aktuelle Strom lesen
//    bAdc = AdcReadData( ADC_CHANNEL_CURRENT );
//    
//      
//      BinToAsciiHexB(bAdc, bAdcWert);
//      bAdcWert[2]= '\n';
//      sendChar( bAdcWert, 3);
//      
//		for( wCount = 0; wCount < 30000; wCount++);
//	}
  
}


//interrupt void Dummy(void)
//{
//	LED_PORT = 0xFF;
//	
//	
//}