;----------------------------------------------------------------
;
;              Generic Startup Routine for
;               Z8 C Compiler Version 4.x
;
;              Copyright 1999-2000 ZiLOG, Inc.
;
;----------------------------------------------------------------
;
;
;
; 11-20-92  DCF   Initial version
;
  INCLUDE "config_ub88xx.inc"

;*****************************************
;
;   Start of code
;
;*****************************************

; Filled in by install program
;<CPU>  I.E. CPU = Z8601

  XDEF  _c_startup
  XDEF  __done
  XDEF  _errno

;
; Reset vector
;
;  VECTOR  reset=_c_startup

  segment CODE
;  DW 0AA99h   ; Kennung externes Programm
_c_startup:
  SRP #%10    ; Set register pointer

;
; Initialize hardware stack
;
 IF INITSP
   IF   MODEL == LARGE
      LD  SPL,#low(_far_stack+1)
      LD  SPH,#high(_far_stack+1)
   ELIF MODEL == MEDIUM
      LD  SPL,#low(_far_stack+1)
      LD  SPH,#high(_far_stack+1) & %f
   ELSE
      LD  SPL,#(_near_stack+1) & %ff
      LD  SPH,#%00
   ENDIF
;      LD  P01M,#((A12_A15<<6)|(AD0_AD7<<3)|A8_A11|((MODEL & 1)<< 2))|SLOW
;      LD  P01M,#%96
 ENDIF

;
; Call main
;
  CALL  _main
__done:
  JR  __done

;*****************************************
;
;   Data area
;
;*****************************************
  IF MODEL == LARGE
  SEGMENT FAR_BSS
_errno  DS  2
  ELSE
  SEGMENT NEAR_BSS
_errno  DS  2
  ENDIF


  SEGMENT NEAR_BSS

  IF HEAP
  XREF  _far_heaptop
  XREF  _far_heapbot
  XDEF  __heaptop
  XDEF  __heapbot
  XDEF  __allocp
__heaptop:
    DS  2
__heapbot:
    DS  2
__allocp:
    DS  2
  ENDIF

  XDEF  __fp
__fp:
  DS  2

  XREF  _main:ROM
 IF CLRRRAM
  XREF  _low_nearbss
  XREF  _len_nearbss
 ENDIF
 IF CLRXRAM
  XREF  _low_farbss
  XREF  _len_farbss
 ENDIF
 IF CLRERAM && PROCESSOR == Z8PLUS
        XREF    _low_medbss
        XREF    _len_medbss
 ENDIF
 IF COPYRRAM
  XREF  _low_neardata
  XREF  _len_neardata
  XREF  _low_near_romdata
 ENDIF
 IF COPYXRAM
  XREF  _low_fardata
  XREF  _len_fardata
  XREF  _low_far_romdata
 ENDIF

 IF COPYXRAM && PROCESSOR == Z8PLUS
        XREF    _low_meddata
        XREF    _len_meddata
        XREF    _low_med_romdata
 ENDIF

  XREF  _far_stack
  XREF  _near_stack

  END _c_startup
