/******************************************************************************
*                         Steffen Hofmann                                     *
*                             shotech                                         *
*******************************************************************************
*  $Source: ,v $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  17.09.2017 13:53:08
*  Geraete Bezeichnung   :  UB88xx TB4 
*-----------------------------------------------------------------------------*
*- $Id:  ub88xx@shotech.de
*-----------------------------------------------------------------------------*
*
*	Sourcefile
*	----------
*	utils
* UB8820 oder UB8840
*
******************************************************************************/

#include "utils.h"

//==============================================================================
/*! Konvertierung von einem Binr-Zeichen in vier ASCII-HEX-Zeichen
//
//  Diese Routine konvertiert ein Binr-Zeichen in zwei ASCII-HEX-Zeichen.
//
//  \param  bNum     -> Byte, das konvertiert werden soll
//  \param *bString  -> String mit den beiden ASCII-HEX Zeichen
//
//  \return          -> kein Rckgabewert
*/
//==============================================================================
void BinToAsciiHexW(unsigned short wNum, char* bString)
{

	BYTE digit=0;
	BYTE i;
		 
		bString += 4 -1; 			//- pointer + digits
		for( i=0; i<4; i++ )
		{
		digit = wNum & 0x0f;	//- max. unsigned char, nur ein digit
		wNum >>= 4;			//- ein digit nach rechts
		if ( digit > 9 ) digit += 'A'-'0'-10;	// Konvert hex A-F 
		       *bString-- = digit + '0';	// zahl	
                digit = 0;
		}

}

void BinToAsciiHexB(unsigned char bNum, char* bString)
{
  unsigned char i;

  for(i=0; i<2; i++)
  {
    if((bNum & 0x0F) < 10)
      bString[1-i] = (bNum & 0x0F)+'0';
    else
      bString[1-i] = (bNum & 0x0F)+'A'-10;
    // next digit
    bNum = bNum>>4;
  }
}

//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
unsigned char RamTest( unsigned short* pwAdr )
{
	
	unsigned short wCount;
	unsigned char far volatile *pbRam;
	unsigned char bRam = 0;
	
	pbRam = &(*(unsigned char far volatile *)SRAM_ANFANG);
	
	for( wCount = SRAM_ANFANG; wCount < SRAM_ENDE; wCount++ )
	{
	  *pbRam = 0x55;
	   pbRam++;		 
		
	}
	
	pbRam = &(*(unsigned char far volatile *)SRAM_ANFANG);

	  for( wCount = SRAM_ANFANG; wCount < SRAM_ENDE; wCount++ )
	  {
	  	if( *pbRam == 0x55 )
	  		{
	  			 *pbRam = 0x00;
	  			 pbRam++;
	  			 
	  		}
	  		else
	  			{
	  				bRam = 1;
	  				break; 
	  			}
	  	 
	  }
	  
	  *pwAdr = wCount;
	  
	  return bRam;
	  
}
