/******************************************************************************
*                         Steffen Hofmann                                     *
*                             shotech                                         *
*******************************************************************************
*  $Source: ,v $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  17.09.2017 13:53:08
*  Geraete Bezeichnung   :  UB88xx TB4 
*-----------------------------------------------------------------------------*
*- $Id:  ub88xx@shotech.de
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	UART
* UB8820 oder UB8840
*
******************************************************************************/

#ifndef TIMER_H
#define TIMER_H

#include "hw.h"

/*********************************************************************
 * Counter Timer 1 is set up to count down to zero 
 * 10ms with an 8 MHz XTAL. The formula is:
 *
 * 	i = t x p x v
 *
 *		i = desired time interval until end of T/C count
 *		t = input clock period (8 divided by the XTAL freq)
 * 	p = prescalar value (1-64 decimal)
 *		v = T/C value (1-256 decimal)
 *
 *		Therefore, 10ms = 1us x 50 x 200
 *
 *********************************************************************/
 
#define	T1_BLINK		 197	/* T1 max count = 256		*/
#define	PRE1_BLINK	  47	/* T1 modulo n, count = 64 	*/
//#define	PRE1_REACT	0xcb	/* T1 modulo n, count = 54	*/
//#define T1_REACT		0xc8	/* T1 count = 200		*/

void init_timer1( void );
void _Wait( u8 bTo );
interrupt void Timer1(void);

#endif
