/******************************************************************************
*                         Steffen Hofmann                                     *
*                             shotech                                         *
*******************************************************************************
*  $Source: ,v $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  18.09.2017 12:34:14
*  Geraete Bezeichnung   :  UB88xx TB4 
*-----------------------------------------------------------------------------*
*- $Id:  ub88xx@shotech.de
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	types
* UB8820 oder UB8840
*
******************************************************************************/
#ifndef TYPES_H
#define TYPES_H

//allgemeine Define's *********************************************************

//- Datentypen ----------------------------------------------------------------


#ifndef __WIN32__
typedef unsigned char BOOL;
#endif



#ifndef NULL
#define NULL    (0)
#endif

#ifndef EOF
#define EOF     (-1)
#endif

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

//typedef enum {FALSE = 0, TRUE = !FALSE} bool;

//-Funktionspointer in Low Byte und High Byte
#define l_byte(v)  (*(((unsigned char *) (&v))))
#define h_byte(v)  (*(((unsigned char *) (&v) + 1)))

#define LOW(x)  ((short)x & 0x0FF)
#define HIGH(x) ((short)x >> 8)
#define BSW(x)	((((x) >> 8) & 0x00FF) | (((x) << 8) & 0xFF00))
#define _SWAP_BYTE(x)  ((((x&0xf0)>>4)|((x&0x0f)<<4)));

//((tAscii&0xf0)>>4)|((tAscii&0x0f)<<4);

#define MINIMUM(x,y) ((x<y) ? x : y)
#define MAXIMUM(x,y) ((x>y) ? x : y)

/* Exported macro ------------------------------------------------------------*/
/* Common routines */
#define IS_AF(c)  ((c >= 'A') && (c <= 'F'))
#define IS_af(c)  ((c >= 'a') && (c <= 'f'))
#define IS_09(c)  ((c >= '0') && (c <= '9'))
#define ISVALIDHEX(c)  IS_AF(c) || IS_af(c) || IS_09(c)
#define ISVALIDDEC(c)  IS_09(c)
#define CONVERTDEC(c)  (c - '0')

#define CONVERTHEX_alpha(c)  (IS_AF(c) ? (c - 'A'+10) : (c - 'a'+10))
#define CONVERTHEX(c)   (IS_09(c) ? (c - '0') : CONVERTHEX_alpha(c))
	
typedef enum {
   EIN,                      // Schalter ein
   AUS                        // Schalter aus
   } Schalter;

/* Exported types ------------------------------------------------------------*/
typedef signed long  s32;
typedef signed short s16;
typedef signed char  s8;

typedef signed long  const sc32;  /* Read Only */
typedef signed short const sc16;  /* Read Only */
typedef signed char  const sc8;   /* Read Only */

typedef volatile signed long  vs32;
typedef volatile signed short vs16;
typedef volatile signed char  vs8;

typedef volatile signed long  const vsc32;  /* Read Only */
typedef volatile signed short const vsc16;  /* Read Only */
typedef volatile signed char  const vsc8;   /* Read Only */

typedef unsigned long  u32;
typedef unsigned short u16;
typedef unsigned char  u8;

typedef unsigned long  const uc32;  /* Read Only */
typedef unsigned short const uc16;  /* Read Only */
typedef unsigned char  const uc8;   /* Read Only */

typedef volatile unsigned long  vu32;
typedef volatile unsigned short vu16;
typedef volatile unsigned char  vu8;

typedef volatile unsigned long  const vuc32;  /* Read Only */
typedef volatile unsigned short const vuc16;  /* Read Only */
typedef volatile unsigned char  const vuc8;   /* Read Only */

typedef unsigned char BYTE;	//   Type BYTE definition

typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef unsigned long uint32_t;
typedef short int16_t;
typedef long int32_t;
/* enables an unsigned char to be used as a series of booleans */
#define BIT(x)	           (1 << (x))


/* Set and clear bits in I/O registers can also be declared as macros */
#define SETBIT(ADDRESS,S_BIT)   (ADDRESS |= (1<<S_BIT))
#define CLEARBIT(ADDRESS,S_BIT) (ADDRESS &= ~(1<<S_BIT))
#endif
