/******************************************************************************
*                         Steffen Hofmann                                     *
*                             shotech                                         *
*******************************************************************************
*  $Source: ,v $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  17.09.2017 13:53:08
*  Geraete Bezeichnung   :  UB88xx TB4 
*-----------------------------------------------------------------------------*
*- $Id:  ub88xx@shotech.de
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	UART
* UB8820 oder UB8840
*
******************************************************************************/
#ifndef UART_H
#define UART_H

#include "hw.h"

typedef enum { 
	RX_IDLE,
	RX_REC,
	RX_COUNT,
	RX_REC_END 
}TeRs232_Rx;

typedef enum {
	BL_IDLE,
	BL_START_ADR,
	BL_COUNT,
	BL_CRC16,
	BL_JUMP_ADR,
	BL_END
}TeBootState;

#define BOOT_START_ADR   '#' //- 0x23 erstes Zeichen fr Startadresse z.B. #1000 ( 32Bit )
#define BOOT_COUNT       'S' //- 0x53 Anzahl der Bytes, die geschrieben werden sollen ( 32Bit )
#define BOOT_CRC16       '&' //- CRC16 der gesendeten Daten ( 16Bit )
#define BOOT_JUMP        'J' //- Adresse, zu der nach dem Upload gesprungen werden soll. ( 32Bit )
#define BOOT_BYTE        ':' //- einmalige Kennung fr nachfolgende Bytes 

#define UART_ACK         0x06
#define UART_NACK        0x15

void init_uart(void );
void putch_ub88(char);
u8 kbhit(void);
char getch(void);
void sendChar( char *cBuffer, unsigned char bCharCount);
void sendConstChar( const char *cBuffer, unsigned char bCharCount);
interrupt void sio_rxd(void);

#endif
