;***********************************************************************/
;*                                                                     */
;*                       Copyright (C) 1992 by ZiLOG, Inc.             */
;*                                                                     */
;***********************************************************************/

;
; CPU equates
;
  ; CMOS
  Z86C00  EQU   0
  Z86C06  EQU   1
  Z86L06  EQU   2
  Z86C07  EQU   3
  Z86C08  EQU   4
  Z86C09  EQU   5
  Z86C10  EQU   6
  Z86C11  EQU   7
  Z86C17  EQU   8
  Z86C18  EQU   9
  Z86C19  EQU   10
  Z86C20  EQU   11
  Z86C21  EQU   12
  Z86C30  EQU   13
  Z86C40  EQU   14
  Z86C61  EQU   15
  Z86C62  EQU   16
  Z86C89  EQU   17
  Z86C90  EQU   18
  Z86C91  EQU   19
  Z86C93  EQU   20
  Z86C95  EQU   21
  Z86C96  EQU   22
  Z86C27  EQU   23
  Z86127  EQU   24
  Z86C97  EQU   25
  ; NMOS
  Z8600   EQU   Z86C00
  Z8601   EQU   26
  Z8602   EQU   27       ; UB8820
  Z8604   EQU   28       ; UB8840
  Z8610   EQU   Z86C10
  Z8611   EQU   Z86C11
  Z8614   EQU   29
  Z8681   EQU   30
  Z8682   EQU   31
  Z8691   EQU   Z86C91

  Z8PLUS  EQU   50

; Filled in by install program
;<PROCESSOR> I.E.
PROCESSOR EQU Z8604

;
;  TRUE/FALSE equates 
;
  TRUE  EQU 1
  FALSE EQU 0

; 
; Model equates
;
; LS bit is 1 if stack is to be placed
; in internal RAM.
;
  SMALL   EQU  1
  LARGE   EQU  0
  MEDIUM  EQU  2

  SP      EQU  255
  FP      EQU  254

  INPUT   EQU  0
  OUTPUT  EQU  1
  EXT     EQU  2

;
; Set memory model.
;
;<MODEL> I.E.
MODEL EQU SMALL
;
; Address line usage of P01M
;
; Set to INPUT if A12 thru A15 are used for input
; Set to OUTPUT if A12 thru A15 are used for output
; Set to EXT if A12 thru A15 are used for Address bits
;<A12_A15> I.E. 
A12_A15 EQU EXT

; Set to INPUT if A8 thru A11 are used for input
; Set to OUTPUT if A8 thru A11 are used for output
; Set to EXT if A8 thru A11 are used for Address bits
;<A8_A11> I.E.  
A8_A11  EQU EXT

; Set to INPUT if AD0 thru AD7 are used for input
; Set to EXT if AD0 thru AD7 are used for Address bits
;<AD0_AD7> I.E. 
AD0_AD7 EQU EXT

;
; If slow external RAM is used set this to %20,
; otherwise %0.
;
;<SLOW> I.E.   ; bei 7,3728MHz  814ns auf 1,085s
;SLOW  EQU %20  ; Zykluszeit von 750ns auf 1s erweitert @8MHz 1/8MHz *2
SLOW  EQU 0   ; Zykluszeit bei 750ns @8MHz
;
; Set to TRUE if the stack pointer is to be initialized
;
  INITSP  EQU TRUE

;
; Set to TRUE if register ram (c_nearbss) is to be initialized
; to 0's.
;
  CLRRRAM EQU FALSE

;
;       Set to TRUE if extended register ram (c_medbss) is to be initialized
;       to 0's. ONLY VALID FOR Z8PLUS
;
        CLRERAM EQU     FALSE

;
; Set to TRUE if external ram (c_farbss) is to be initialized
; to 0's.
;
  CLRXRAM EQU FALSE

;
; Set to TRUE if (c_neardata) is to be copied from ROM
;
  COPYRRAM EQU  FALSE; TRUE 
;
; Set to TRUE if (c_fardata) is to be copied from ROM
;
  COPYXRAM EQU  FALSE ;TRUE

;
;       Set to TRUE if (c_meddata) is to be copied from ROM
;       ONLY VALID FOR Z8PLUS
;
        COPYERAM EQU    FALSE

;
; Heap used - Set to TRUE if the heap is used, otherwise
; FALSE. If this value is set to FALSE then _malloc and _calloc
; cannot be used.
;
  HEAP  EQU   FALSE

