;----------------------------------------------------------------
;
;              Generic Startup Routine for
;               Z8 C Compiler Version 4.x
;
;              Copyright 1999-2000 ZiLOG, Inc.
;
;----------------------------------------------------------------
;
;
;
; 11-20-92  DCF   Initial version
;
  INCLUDE "config_ub88xx.inc"

;*****************************************
;
;   Start of code
;
;*****************************************

; Filled in by install program
;<CPU>  I.E. CPU = Z8601

  XDEF  _c_startup
  XDEF  __done
  XDEF  _errno
  
  
;
; Reset vector
;
  VECTOR  reset=_c_startup

  segment CODE

_c_startup:
  DI
  SRP #%10    ; Set register pointer

;
; Initialize hardware stack
;
 IF INITSP
   IF   MODEL == LARGE
      LD  SPL,#low(_far_stack+1)
      LD  SPH,#high(_far_stack+1)
   ELIF MODEL == MEDIUM
      LD  SPL,#low(_far_stack+1)
      LD  SPH,#high(_far_stack+1) & %f
   ELSE
      LD  SPL,#(_near_stack+1) & %ff
      LD  SPH,#%00
   ENDIF
      LD  P01M,#((A12_A15<<6)|(AD0_AD7<<3)|A8_A11|((MODEL & 1)<< 2))|SLOW
;      LD  P01M,#%96
 ENDIF
;
; Clear internal ram area (c_nearbss)
;
 IF CLRRRAM
      LD  R0,#_low_nearbss
      LD  R2,#_len_nearbss
      CP  R2,#0
      JR  Z,lab4
lab3:
      CLR @R0
      INC R0
      DJNZ  R2,lab3
lab4:
 ENDIF

;
; Clear external ram area (c_farbss)
;
 IF CLRXRAM
  LD  R2,#high(_low_farbss)
  LD  R3,#low(_low_farbss)
  LD  R0,#high(_len_farbss)
  LD  R1,#low(_len_farbss)

  LD  R4,R0
  OR  R4,R1
  JR  Z,lab6
  CLR R4
lab5:
  LDE @RR2,R4
  INCW  RR2
  DECW  RR0
  JR  NZ,lab5
lab6:
 ENDIF

;
;       Clear extended ram area (c_medbss)
;       nicht benutzt bei ub88xx
 IF CLRERAM && PROCESSOR == Z8PLUS
        LD      R2,#high(_low_medbss)
        LD      R3,#low(_low_medbss)
        LD      R0,#high(_len_medbss)
        LD      R1,#low(_len_medbss)

  LD  R4,R0
  OR  R4,R1
        JR      Z,lab8
  CLR R4
lab7:
        LD      RP,R2           ; !!!!! Wrong !!!!!
        LDX     @R2,R4          ; !!!!! Wrong !!!!!
        LD      RP,%0
  INCW  RR2
  DECW  RR0
        JR      NZ,lab7
lab8:
 ENDIF
;
; Copy ROM data into internal RAM
;
 IF COPYRRAM
  LD  R0,#high(_low_near_romdata)
  LD  R1,#low(_low_near_romdata)
  LD  R3,#_len_neardata
  LD  R4,#_low_neardata
  OR  R3,R3
        JR      Z,lab10
lab9:
  LDCI  @R4,@RR0
        DJNZ    R3,lab9
lab10:
 ENDIF

;
; Copy ROM data into external RAM
;
 IF COPYXRAM
  LD  R0,#high(_low_fardata)
  LD  R1,#low(_low_fardata)
  LD  R2,#high(_low_far_romdata)
  LD  R3,#low(_low_far_romdata)
  LD  R4,#high(_len_fardata)
  LD  R5,#low(_len_fardata)

  LD  R6,R4
  OR  R6,R5
  JR  Z,lab12

lab11:
  LDC R6,@RR2
  LDE @RR0,R6
  INCW  RR0
  INCW  RR2
  DECW  RR4
  JR  NZ,lab11

lab12:
 ENDIF

;
;       Copy ROM data into extended register RAM
;
 IF COPYERAM && PROCESSOR = Z8PLUS
        LD      R0,#high(_low_meddata)
        LD      R1,#low(_low_meddata)
        LD      R2,#high(_low_med_romdata)
        LD      R3,#low(_low_med_romdata)
        LD      R4,#high(_len_meddata)
        LD      R5,#low(_len_meddata)

  LD  R6,R4
  OR  R6,R5
        JR      Z,lab14

lab13:
  LDC R6,@RR2
        LD      RP,R0           ; !!!!! Wrong !!!!!
        LDX     @R1,R6          ; !!!!! Wrong !!!!!
  INCW  RR0
  INCW  RR2
  DECW  RR4
        JR      NZ,lab13

lab14:
 ENDIF

;
; Initialize heap pointers
;
 IF HEAP
  LD  __heaptop,#high(_far_heaptop)
  LD  __heaptop+1,#low(_far_heaptop)
  LD  __heapbot,#high(_far_heapbot)
  LD  __heapbot+1,#low(_far_heapbot)
 ENDIF
;
; Call main
;
  CALL  _main
__done:
  JR  __done


   
;*****************************************
;
;   Data area
;
;*****************************************
  IF MODEL == LARGE
  SEGMENT FAR_BSS
_errno  DS  2
  ELSE
  SEGMENT NEAR_BSS
_errno  DS  2
  ENDIF


  SEGMENT NEAR_BSS

  IF HEAP
  XREF  _far_heaptop
  XREF  _far_heapbot
  XDEF  __heaptop
  XDEF  __heapbot
  XDEF  __allocp
__heaptop:
    DS  2
__heapbot:
    DS  2
__allocp:
    DS  2
  ENDIF

  XDEF  __fp
__fp:
  DS  2

  XREF  _main:ROM
 IF CLRRRAM
  XREF  _low_nearbss
  XREF  _len_nearbss
 ENDIF
 IF CLRXRAM
  XREF  _low_farbss
  XREF  _len_farbss
 ENDIF
 IF CLRERAM && PROCESSOR == Z8PLUS
        XREF    _low_medbss
        XREF    _len_medbss
 ENDIF
 IF COPYRRAM
  XREF  _low_neardata
  XREF  _len_neardata
  XREF  _low_near_romdata
 ENDIF
 IF COPYXRAM
  XREF  _low_fardata
  XREF  _len_fardata
  XREF  _low_far_romdata
 ENDIF

 IF COPYXRAM && PROCESSOR == Z8PLUS
        XREF    _low_meddata
        XREF    _len_meddata
        XREF    _low_med_romdata
 ENDIF

  XREF  _far_stack
  XREF  _near_stack

  END _c_startup
